; =========================================================================== ;
; Atomic-OS Assembly header :-)                                               ;
;                                                                             ;
; To be assembled with NASM because it works better with C than FASM.         ;
; =========================================================================== ;
	[BITS 32]
	[global start]                ; Tell NASM were our
	[extern main] 		      ; this is our C code
start:
	mov	 ax, 0x10	      ; Move the data segment into AX then
	mov	 ss, ax 	      ; into SS, DS, and ES.
	mov	 ds, ax
	mov	 es, ax
	mov	 fs, ax
	mov	 gs, ax
	sti

	mov	edi, 0x000B8000       ; Point EDI to video memory
	mov	 cx, 0x03E8           ; How many cols to clear (80*25)/2
	mov	eax, 0x07200720       ; Gray on black spaces
	rep	stosd                 ; Clear the screen.
	mov	 di, 0x8000
	mov	 ax, " 1"
	stosb

	pop	 ax                   ; Pop boot drive off the stack.
	mov	 si, bootdrive        ; Point ESI at the bootdrive store
	stosb                         ; esi[0] = ax;
	sti

	mov	esp, 0x7C00           ; Stack pointer gives us ~2kb of stack.
	call	main                  ; Call the C code.

_returnfc:
	hlt
	jmp	_returnfc

bootdrive db 0x00
